<?xml version="1.0" encoding="UTF-8"?>
<?xmlspysamplexml C:\My Documents\ACORD\Spec\Version 1-5\Schema_With_Namespace\acord-pc-v1_5_0-ns-nodoc-codes.xsd?>
<!--
$Workfile: SchemaExtractOne.xslt $

$Author: Ed Trembicki-Guy $
$Date: 2004.06.08 17:30p $

Version Number 1
______________

$Revision: 2 $

COPYRIGHT NOTICE
________________

(c) 2004 Marsh USA, Inc. All Rights Reserved.

Usage Information
__________________

  This stylesheet is part one of a set of two.  This
  stylesheet processes a base W3C schema definition, a redefinition
  schema and an extension schema.  It extracts all the elementDefs
  from the base schema required to support the message(s) or aggregate
  name(s) provided in the $RequestType parameter, and merges in any 
  redefinition information. If more than one name is provided in $RequestType, each
  must be separated from the previous by a comma (no spaces).
  This effectively subsets the base schema to a 
  smaller unit that contains everything needed to validate 
  that message or aggregate, as redefined by the original redefinition
  schema.  The reason for the merge is so that the resultant schema can be used
  with JAXB, which currently (rev 1.0), does not support the redefine tag. 
  The second stylesheet in the pair completes the process by extracting only the extension
  elements necessary to validate the the message or aggregate.
  
  The command line would be:
  
        saxon -o base_msg.xsd base_schema.xsd SchemaExtractOne.xslt RequestType=elementname(s)
        saxon -o extension_msg.xsd  base_msg.xsd SchemaExtractTwo.xslt RequestType=elementname(s)

	NOTE: This stylesheet makes use of SAXON extensions and
	      SAXON can be found at: http://saxon.sourceforge.net/
	      
	Besides RequestType, the following parameters can be set on the command line:
	baseNS - base namespace alias in extension schema (default = acord:)
	extNS - extension namespace alias in redefinition schema (default = Marsh:)
	redefFile - redefinition schema file (default = file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh_ACORD_1-5-0.xsd)
	extFile - extension schema file (file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh.xsd)
-->

<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	xmlns:Marsh="http://www.marsh.com/"
	xmlns:saxon="http://icl.com/saxon" 
	extension-element-prefixes="saxon">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:param name="RequestType" select="'CertificateInsuranceInqRq'"/>

	<xsl:param name="baseNS" select="'acord:'"/>
	
	<xsl:param name="extNS" select="'Marsh:'"/>
	
	<xsl:param name="redefFile" select="'file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh_ACORD_1-5-0.xsd'"/>
	
	<xsl:param name="extFile" select="'file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh.xsd'"/>
	
	<xsl:variable name="myRoot" select="''" saxon:assignable="yes"/>
	
	<xsl:variable name="elementList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="complexTypeList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="groupList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="simpleTypeList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="marshElementList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="marshComplexTypeList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="marshGroupList" select="''" saxon:assignable="yes"/>
	
	<xsl:template match="/xsd:schema">
		<saxon:assign name="myRoot" select="."/>
		<xsl:message><xsl:text>The RequestType value is </xsl:text><xsl:value-of select="$RequestType"/></xsl:message>
		<xsl:variable name="target" select="@targetNamespace" saxon:assignable="yes"/>
			<!-- part of trick to make the namespace appear on schema element -->
			<xsl:variable name="ns-node" saxon:assignable="yes">
			   <xsl:element name="ns-element" namespace="{$target}"/>
			</xsl:variable>
			<xsd:schema xmlns:acord="http://www.ACORD.org/standards/Support/xml/v1.0">
			<!-- the rest of the namespace trick -->
			<xsl:copy-of select="saxon:node-set($ns-node)/*/namespace::*[local-name()='']"/>
			<xsl:attribute name="targetNamespace"><xsl:value-of select="$target"/></xsl:attribute>
			<saxon:assign name="target" select="document($redefFile)/xs:schema/@targetnamespace"/>
			<saxon:assign name="ns-node">
			   <xsl:element name="ns-element" namespace="{$target}"/>
			</saxon:assign>
			<xsl:copy-of select="saxon:node-set($ns-node)/*/namespace::*[local-name()='']"/>
			<saxon:assign name="target" select="document($extFile)/xs:schema/@targetnamespace"/>
			<saxon:assign name="ns-node">
			   <xsl:element name="ns-element" namespace="{$target}"/>
			</saxon:assign>
			<xsl:copy-of select="saxon:node-set($ns-node)/*/namespace::*[local-name()='']"/>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsd:annotation>
				<xsd:appinfo>
					<xsd:documentation>This schema has been extracted using the following parameters:
					RequestType: <xsl:value-of select="$RequestType"/>
					baseNS: <xsl:value-of select="$baseNS"/>
					extNS: <xsl:value-of select="$extNS"/>
					redefFile: <xsl:value-of select="$redefFile"/>
					extFile: <xsl:value-of select="$extFile"/>
					</xsd:documentation>
				</xsd:appinfo>
			</xsd:annotation>
			<xsl:for-each select="xsd:import">
				<xsl:copy-of select="."/>
			</xsl:for-each>
			<xsl:for-each select="document($redefFile)/xs:schema/xs:import">
				<xsl:copy-of select="."/>
			</xsl:for-each>
			<xsl:call-template name="processRequestType">
				<xsl:with-param name="req" select="$RequestType"/>
			</xsl:call-template>
		</xsd:schema>
	</xsl:template>
	
	<xsl:template name="processRequestType">
		<xsl:param name="req"/>
		<xsl:variable name="firstReq" select="$req" saxon:assignable="yes"/>
		<xsl:variable name="nextReq" select="''" saxon:assignable="yes"/>
		<xsl:if test="contains($req, ',')">
			<saxon:assign name="firstReq" select="substring-before($req, ',')"/>
			<saxon:assign name="nextReq" select="substring-after($req, ',')"/>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="starts-with($firstReq, $extNS)">
				<xsl:message>Processing: <xsl:value-of select="$firstReq"/></xsl:message>
				<saxon:assign name="firstReq" select="substring-after($firstReq, $extNS)"/>
				<xsl:apply-templates select="document($extFile)/xs:schema/xs:element[@name=$firstReq]" mode="Marsh"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:message>Processing: <xsl:value-of select="$firstReq"/></xsl:message>
				<xsl:apply-templates select="xsd:element[@name=$firstReq]" mode="resolve"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="not($nextReq='')">
			<xsl:call-template name="processRequestType">
				<xsl:with-param name="req" select="$nextReq"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:element" mode="resolve">
		<xsl:if test="not(contains($elementList, concat(' ', @name, ' ')))">
			<saxon:assign name="elementList" select="concat($elementList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:choose>
				<xsl:when test="@type">
					<xsl:variable name="myType" select="@type"/>
					<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myType]" mode="resolve"/>
					<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myType]" mode="resolve"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="*" mode="resolve"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xs:element" mode="Marsh">
		<xsl:if test="not(contains($marshElementList, concat(' ', @name, ' ')))">
			<saxon:assign name="marshElementList" select="concat($marshElementList, ' ', @name, ' ')"/>
			<xsl:choose>
				<xsl:when test="@type">
					<xsl:variable name="myType" select="@type"/>
					<xsl:choose>
						<xsl:when test="starts-with($myType, $baseNS)">
							<xsl:apply-templates select="$myRoot/xsd:complexType[@name=substring-after($myType, $baseNS)]" mode="resolve"/>
							<xsl:apply-templates select="$myRoot/xsd:simpleType[@name=substring-after($myType, $baseNS)]" mode="resolve"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:apply-templates select="/xs:schema/xs:complexType[@name=$myType]" mode="Marsh"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="resolveMarshGroup">
						<xsl:with-param name="nodeHome" select="."/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:complexType" mode="resolve">
		<xsl:variable name="myComplexType" select="@name"/>
		<xsl:variable name="hasOverride" select="false()"  saxon:assignable="yes"/>
		<xsl:if test="not(@name) or not(contains($complexTypeList, concat(' ', @name, ' ')))">
			<xsl:if test="@name">
				<saxon:assign name="complexTypeList" select="concat($complexTypeList, ' ', @name, ' ')"/>
				<xsl:choose>
					<xsl:when test="document($redefFile)//*[@name=$myComplexType]">
						<saxon:assign name="hasOverride" select="true()"/>
						<xsl:message>
							<xsl:text>Found an Override! - </xsl:text><xsl:value-of select="$myComplexType"/>
						</xsl:message>
						<xsl:copy>
							<xsl:for-each select="@*">
								<xsl:copy/>
							</xsl:for-each>
							<xsl:apply-templates select="*" mode="copy">
								<xsl:with-param name="ext" select="@name"/>
							</xsl:apply-templates>
						</xsl:copy>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy-of select="."/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			<xsl:call-template name="resolveGroup">
				<xsl:with-param name="nodeHome" select="."/>
				<xsl:with-param name="hasOverride" select="$hasOverride"/>
				<xsl:with-param name="myComplexType" select="$myComplexType"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template match="xs:complexType" mode="Marsh">
		<xsl:if test="not(contains($marshComplexTypeList, concat(' ', @name, ' ')))">
			<saxon:assign name="marshComplexTypeList" select="concat($marshComplexTypeList, ' ', @name, ' ')"/>
			<xsl:call-template name="resolveMarshGroup">
				<xsl:with-param name="nodeHome" select="."/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template match="xs:group" mode="Marsh">
		<xsl:if test="not(contains($marshGroupList, concat(' ', @name, ' ')))">
			<saxon:assign name="marshGroupList" select="concat($marshGroupList, ' ', @name, ' ')"/>
			<xsl:call-template name="resolveMarshGroup">
				<xsl:with-param name="nodeHome" select="."/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template name="resolveGroup">
		<xsl:param name="nodeHome" select="/"/>
		<xsl:param name="hasOverride" select="false()"/>
		<xsl:param name="myComplexType"/>
		<xsl:for-each select="$nodeHome//xsd:element">
			<xsl:variable name="myElementRef" select="@ref"/>
			<xsl:apply-templates select="/xsd:schema/xsd:element[@name=$myElementRef]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:group">
			<xsl:variable name="myGroupRef" select="@ref"/>
			<xsl:apply-templates select="/xsd:schema/xsd:group[@name=$myGroupRef]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:extension">
			<xsl:variable name="myExtensionBase" select="@base"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myExtensionBase]" mode="resolve"/>
			<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myExtensionBase]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:restriction">
			<xsl:variable name="myRestrictionBase" select="@base"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myRestrictionBase]" mode="resolve"/>
			<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myRestrictionBase]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:attribute">
			<xsl:variable name="myType" select="@type"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myType]" mode="resolve"/>
		</xsl:for-each>
		<xsl:variable name="docRoot" select="/xsd:schema"/>
		<xsl:variable name="extRoot" select="document($extFile)/xs:schema"/>
		<xsl:if test="$hasOverride=true()">
			<xsl:for-each select="document($redefFile)//*[@name=$myComplexType]//xsd:element">
				<xsl:variable name="myElementRef" select="@ref"/>
				<xsl:choose>
					<xsl:when test="starts-with($myElementRef, $extNS)">
						<xsl:apply-templates select="$extRoot/xs:element[@name=substring-after($myElementRef, $extNS)]" mode="Marsh"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="$docRoot/xsd:element[@name=$myElementRef]" mode="resolve"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:for-each select="document($redefFile)//*[@name=$myComplexType]//xsd:group">
				<xsl:variable name="myGroupRef" select="@ref"/>
				<xsl:choose>
					<xsl:when test="starts-with($myGroupRef, $extNS)">
						<xsl:apply-templates select="$extRoot/xs:group[@name=substring-after($myGroupRef, $extNS)]" mode="Marsh"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="$docRoot/xsd:group[@name=$myGroupRef]" mode="resolve"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:for-each select="document($redefFile)//*[@name=$myComplexType]//xsd:extension">
				<xsl:variable name="myExtensionBase" select="@base"/>
				<xsl:apply-templates select="$docRoot/xsd:simpleType[@name=$myExtensionBase]" mode="resolve"/>
				<xsl:apply-templates select="$docRoot/xsd:complexType[@name=$myExtensionBase]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select="document($redefFile)//*[@name=$myComplexType]//xsd:restriction">
				<xsl:variable name="myRestrictionBase" select="@base"/>
				<xsl:apply-templates select="$docRoot/xsd:simpleType[@name=$myRestrictionBase]" mode="resolve"/>
				<xsl:apply-templates select="$docRoot/xsd:complexType[@name=$myRestrictionBase]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select="document($redefFile)//*[@name=$myComplexType]/xsd:attribute">
				<xsl:variable name="myType" select="@type"/>
				<xsl:apply-templates select="$docRoot/xsd:simpleType[@name=$myType]" mode="resolve"/>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="resolveMarshGroup">
		<xsl:param name="nodeHome" select="/"/>
		<xsl:for-each select="$nodeHome//xsd:element">
			<xsl:variable name="myElementRef" select="@ref"/>
			<xsl:choose>
				<xsl:when test="starts-with($myElementRef, $baseNS)">
					<xsl:apply-templates select="$myRoot/xsd:element[@name=substring-after($myElementRef, $baseNS)]" mode="resolve"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="/xsd:schema/xsd:element[@name=$myElementRef]" mode="Marsh"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:group">
			<xsl:variable name="myGroupRef" select="@ref"/>
			<xsl:choose>
				<xsl:when test="starts-with($myGroupRef, $baseNS)">
					<xsl:apply-templates select="$myRoot/xsd:group[@name=substring-after($myGroupRef, $baseNS)]" mode="resolve"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="/xsd:schema/xsd:group[@name=$myGroupRef]" mode="Marsh"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:extension">
			<xsl:variable name="myExtensionBase" select="@base"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myExtensionBase]" mode="resolve"/>
			<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myExtensionBase]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome//xsd:restriction">
			<xsl:variable name="myRestrictionBase" select="@base"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myRestrictionBase]" mode="resolve"/>
			<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myRestrictionBase]" mode="resolve"/>
		</xsl:for-each>
		<xsl:for-each select="$nodeHome/xsd:attribute">
			<xsl:variable name="myType" select="@type"/>
			<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myType]" mode="resolve"/>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template match="xsd:group" mode="resolve">
		<xsl:if test="not(contains($groupList, concat(' ', @name, ' ')))">
			<saxon:assign name="groupList" select="concat($groupList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:for-each select=".//xsd:element">
				<xsl:variable name="myElementRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:element[@name=$myElementRef]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select=".//xsd:group">
				<xsl:variable name="myGroupRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:group[@name=$myGroupRef]" mode="resolve"/>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:simpleType" mode="resolve">
		<xsl:if test="not(contains($simpleTypeList, concat(' ', @name, ' ')))">
			<saxon:assign name="simpleTypeList" select="concat($simpleTypeList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:if test="not(starts-with(xsd:restriction/@base, 'xsd:'))">
				<xsl:variable name="myBase" select="xsd:restriction/@base"/>
				<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myBase]" mode="resolve"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:simpleContent | xsd:complexContent | xsd:restriction | xsd:extension" mode="copy">
		<xsl:param name="ext"/>
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:apply-templates select="*" mode="copy">
				<xsl:with-param name="ext" select="$ext"/>
			</xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="xsd:sequence | xsd:choice" mode="copy">
		<xsl:param name="ext"/>
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsl:apply-templates select="*" mode="copy"/>
			<xsl:apply-templates select="document($redefFile)//*[@name=$ext]//xsd:element" mode="MarshCopy"/>
			<xsl:apply-templates select="document($redefFile)//*[@name=$ext]//xsd:group" mode="MarshCopy"/>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="xsd:element | xsd:group | xsd:attribute" mode="copy">
		<xsl:copy-of select="."/>
	</xsl:template>

	<xsl:template match="*" mode="MarshCopy">
		<xsl:element name="{name()}">
			<xsl:for-each select="@*">
				<xsl:attribute name="{name()}"><xsl:value-of select="."/></xsl:attribute>
			</xsl:for-each>
			<xsl:apply-templates select="*" mode="MarshCopy"/>
		</xsl:element>
	</xsl:template>

</xsl:stylesheet>
