<?xml version="1.0" encoding="UTF-8"?>
<?xmlspysamplexml C:\My Documents\ACORD\Spec\Version 1-5\Schema_With_Namespace\acord-pc-v1_5_0-ns-nodoc-codes.xsd?>
<!--
$Workfile: SchemaExtractTwo.xslt $

$Author: Ed Trembicki-Guy $
$Date: 2004.06.08 17:30p $

Version Number 1
______________

$Revision: 2 $

COPYRIGHT NOTICE
________________

(c) 2004 Marsh USA, Inc. All Rights Reserved.

Usage Information
__________________

  This stylesheet is part two of a set of two.  This
  stylesheet processes a base W3C schema definition, a redefinition
  schema and an extension schema.  It extracts all the elementDefs
  from the extension schema required to support the message(s) or aggregate
  name(s) provided in the $RequestType parameter. If more than one name is
  provided in $RequestType, each must be separated from the previous by a
  comma (no spaces).
  This effectively subsets the extension schema to a 
  smaller unit that contains everything needed to validate 
  that message or aggregate. 
  The first stylesheet in the pair perfomed the extract on the base schema.
  
  The command line would be:
  
        saxon -o base_msg.xsd base_schema.xsd SchemaExtractOne.xslt RequestType=elementname(s)
        saxon -o extension_msg.xsd  base_msg.xsd SchemaExtractTwo.xslt RequestType=elementname(s)

	NOTE: This stylesheet makes use of SAXON extensions and
	      SAXON can be found at: http://saxon.sourceforge.net/
	      
	Besides RequestType, the following parameters can be set on the command line:
	extNS - extension namespace alias in redefinition schema (default = Marsh:)
	extFile - extension schema file (file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh.xsd)
	
	It is expected that the above parameters will have the identical values as those provided to 
	the first stylesheet.
-->


<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
	xmlns:xs="http://www.w3.org/2001/XMLSchema" 
	xmlns:Marsh="http://www.marsh.com/"
	xmlns:saxon="http://icl.com/saxon" 
	extension-element-prefixes="saxon">

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	
	<xsl:param name="RequestType" select="'CertificateInsuranceInqRq'"/>
	
	<xsl:param name="extNS" select="'Marsh:'"/>
	
	<xsl:param name="extFile" select="'file:/c:/MYDOCU~1/Marsh/ACORD/XSD/Marsh.xsd'"/>
		
	<xsl:variable name="elementList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="complexTypeList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="groupList" select="''" saxon:assignable="yes"/>
	<xsl:variable name="simpleTypeList" select="''" saxon:assignable="yes"/>
	
	<xsl:template match="/xsd:schema">
		<xsl:message>RequestType = <xsl:value-of select="$RequestType"/></xsl:message>
		<xsl:apply-templates select="document($extFile)/xs:schema" mode="extensions">
			<xsl:with-param name="mainDoc" select="."/>
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match="/xsd:schema" mode="extensions">
		<xsl:param name="mainDoc"/>
		<xsl:copy>
			<xsl:for-each select="@*">
				<xsl:copy/>
			</xsl:for-each>
			<xsd:annotation>
				<xsd:appinfo>
					<xsd:documentation>This schema has been extracted using the following parameters:
					RequestType: <xsl:value-of select="$RequestType"/>
					extNS: <xsl:value-of select="$extNS"/>
					extFile: <xsl:value-of select="$extFile"/>
					</xsd:documentation>
				</xsd:appinfo>
			</xsd:annotation>
			<xsl:for-each select="xsd:import">
				<xsl:copy-of select="."/>
			</xsl:for-each>
			<xsl:if test="not($RequestType='')">
				<xsl:call-template name="processRequestType">
					<xsl:with-param name="req" select="$RequestType"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:for-each select="$mainDoc//*">
				<xsl:if test="@ref and starts-with(@ref, $extNS)">
					<xsl:variable name="myRef" select="@ref"/>
					<xsl:for-each select="document($extFile)/xs:schema/xs:element[@name=substring-after($myRef, ':')]">
						<xsl:message><xsl:text>Processing: </xsl:text><xsl:value-of select="$myRef"/></xsl:message>
						<xsl:apply-templates select="." mode="resolve"/>
					</xsl:for-each>
				</xsl:if>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="processRequestType">
		<xsl:param name="req"/>
		<xsl:variable name="firstReq" select="$req" saxon:assignable="yes"/>
		<xsl:variable name="nextReq" select="''" saxon:assignable="yes"/>
		<xsl:message>In processRequestType req=<xsl:value-of select="$req"/></xsl:message>
		<xsl:if test="contains($req, ',')">
			<saxon:assign name="firstReq" select="substring-before($req, ',')"/>
			<saxon:assign name="nextReq" select="substring-after($req, ',')"/>
		</xsl:if>
		<xsl:if test="starts-with($firstReq, $extNS)">
			<xsl:message>Resolving: <xsl:value-of select="$firstReq"/></xsl:message>
			<saxon:assign name="firstReq" select="substring-after($firstReq, $extNS)"/>
			<xsl:apply-templates select="xs:element[@name=$firstReq]" mode="resolve"/>
		</xsl:if>
		<xsl:if test="not($nextReq='')">
			<xsl:call-template name="processRequestType">
				<xsl:with-param name="req" select="$nextReq"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:element" mode="resolve">
		<xsl:if test="not(contains($elementList, concat(' ', @name, ' ')))">
			<saxon:assign name="elementList" select="concat($elementList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:choose>
				<xsl:when test="@type">
					<xsl:variable name="myType" select="@type"/>
					<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myType]" mode="resolve"/>
					<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myType]" mode="resolve"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:for-each select="xsd:complexType">
						<xsl:apply-templates select="." mode="resolve"/>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:complexType" mode="resolve">
		<xsl:if test="not(@name) or not(contains($complexTypeList, concat(' ', @name, ' ')))">
			<xsl:if test="@name">
				<saxon:assign name="complexTypeList" select="concat($complexTypeList, ' ', @name, ' ')"/>
				<xsl:copy-of select="."/>
			</xsl:if>
			<xsl:for-each select=".//xsd:element">
				<xsl:variable name="myElementRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:element[@name=$myElementRef]" 	mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select=".//xsd:group">
				<xsl:variable name="myGroupRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:group[@name=$myGroupRef]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select=".//xsd:extension">
				<xsl:variable name="myExtensionBase" select="@base"/>
				<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myExtensionBase]" mode="resolve"/>
				<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myExtensionBase]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select=".//xsd:restriction">
				<xsl:variable name="myRestrictionBase" select="@base"/>
				<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myRestrictionBase]" mode="resolve"/>
				<xsl:apply-templates select="/xsd:schema/xsd:complexType[@name=$myRestrictionBase]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select="xsd:attribute">
				<xsl:variable name="myType" select="@type"/>
				<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myType]" mode="resolve"/>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:group" mode="resolve">
		<xsl:if test="not(contains($groupList, concat(' ', @name, ' ')))">
			<saxon:assign name="groupList" select="concat($groupList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:for-each select=".//xsd:element">
				<xsl:variable name="myElementRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:element[@name=$myElementRef]" mode="resolve"/>
			</xsl:for-each>
			<xsl:for-each select=".//xsd:group">
				<xsl:variable name="myGroupRef" select="@ref"/>
				<xsl:apply-templates select="/xsd:schema/xsd:group[@name=$myGroupRef]" mode="resolve"/>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="xsd:simpleType" mode="resolve">
		<xsl:if test="not(contains($simpleTypeList, concat(' ', @name, ' ')))">
			<saxon:assign name="simpleTypeList" select="concat($simpleTypeList, ' ', @name, ' ')"/>
			<xsl:copy-of select="."/>
			<xsl:if test="not(starts-with(xsd:restriction/@base, 'xsd:'))">
				<xsl:variable name="myBase" select="xsd:restriction/@base"/>
				<xsl:apply-templates select="/xsd:schema/xsd:simpleType[@name=$myBase]" mode="resolve"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
